#pragma once

#include "rf60Xsdk.h"
#include "rf60Xtypes.h"
#include <cliext/vector>
#include <msclr\marshal.h>



using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Text;
using namespace msclr::interop;
using namespace System::IO;


namespace rf60Xsdk {

	   	  
	public enum class SCANNER_TYPE_NET
	{
		RF60x = 1, RF60xHS = 2, RF60xB = 3
	};

	public enum class BAUR_RATE_UART_NET {
		Baud9600 = 0x04,
		Baud115200 = 0x30,
		Baud230400 = 0x60,
		Baud460800 = 0xC0,
		Baud921600 = 0x180,

	};

	public enum class COMMAND_UART_NET {
		WRITEPARAM = 0x03,
		SAVETOFLASH = 0x04AA,
		RESTOREFORMFLASH = 0x0469,
		START_STREAM = 0x07,
		STOP_STREAM = 0x08
	};

	public enum class PROTOCOLS_NET : uint8_t {
		RIFTEK_BIN_PROTOCOL = 1,
		ASCII = 2,
		MODBUS_RTU = 3,
	};


	public enum class PARAM_NAME_KEY_NET {
		USER_POWER = 0,
		POWER_ANALOG_OUTPUT,
		CONTROL_OF_AVERAGING,
		NETWORK_ADDRESS_UART,
		BAUD_RATE_UART,
		NUMBER_OF_AVERAGED_VALUES,
		LOW_BYTE_OF_THE_SAMPLING_PERIOD,
		HIGH_BYTE_OF_THE_SAMPLING_PERIOD,
		LOW_BYTE_OF_MAX_INTEGRATION_TIME,
		HIGH_BYTE_OF_MAX_INTEGRATION_TIME,
		LOW_BYTE_FOR_THE_BEGINNING_OF_ANALOG_OUT_RANGE,
		HIGH_BYTE_FOR_THE_BEGINNING_OF_ANALOG_OUT_RANGE,
		LOW_BYTE_FOR_THE_END_OF_ANALOG_OUT_RANGE,
		HIGH_BYTE_FOR_THE_END_OF_ANALOG_OUT_RANGE,
		TIME_LOCK_OF_RESULT,
		LOW_BYTE_OF_A_ZERO_POINT,
		HIGH_BYTE_OF_A_ZERO_POINT,
		DATA_TRANSFER_RATE_VIA_CAN_INTERFACE,
		LOW_BYTE_OF_STANDARD_IDENTIFIER,
		HIGH_BYTE_OF_STANDARD_IDENTIFIER,
		ZERO_BYTE_OF_EXTENDED_IDENTIFIER,
		FIRST_BYTE_OF_EXTENDED_IDENTIFIE,
		SECOND_BYTE_OF_EXTENDED_IDENTIFIER,
		THIRD_BYTE_OF_EXTENDED_IDENTIFIER,
		CAN_INTERFACE_IDENTIFIER,
		CAN_INTERFACE_POWER_SWITCH,
		ZERO_BYTE_OF_DESTINATION_IP_ADDRESS,
		FIRST_BYTE_OF_DESTINATION_IP_ADDRESS,
		SECOND_BYTE_OF_DESTINATION_IP_ADDRESS,
		THIRD_BYTE_OF_DESTINATION_IP_ADDRESS,
		ZERO_BYTE_OF_GATEWAY_IP_ADDRESS,
		FIRST_BYTE_OF_GATEWAY_IP_ADDRESS,
		SECOND_BYTE_OF_GATEWAY_IP_ADDRESS,
		THIRD_BYTE_OF_GATEWAY_IP_ADDRESS,
		ZERO_BYTE_OF_SUBNET_MASK,
		FIRST_BYTE_OF_SUBNET_MASK,
		SECOND_BYTE_OF_SUBNET_MASK,
		THIRD_BYTE_OF_SUBNET_MASK,
		ZERO_BYTE_OF_SOURCE_IP_ADDRESS,
		FIRST_BYTE_OF_SOURCE_IP_ADDRESS,
		SECOND_BYTE_OF_SOURCE_IP_ADDRESS,
		THIRD_BYTE_OF_SOURCE_IP_ADDRESS,
		LOW_BYTE_OF_THE_NUMBER_OF_MEASUREMENTS_IN_THE_PACKET,
		HIGH_BYTE_OF_THE_NUMBER_OF_MEASUREMENTS_IN_THE_PACKET,
		ETH_INTERFACE_ON_OFF,
		AUTO_OF_THE_STREAM,
		PROTOCOLS_INTERFACE
	};



	[StructLayout(LayoutKind::Sequential, Pack = 1)]
	public value struct uart_hello_rf60x_net_t
	{
		uint8_t  deviceType;
		uint8_t  deviceModificaton;
		uint16_t deviceSerial;
		uint16_t deviceMaxDistance;
		uint16_t deviceRange;
	};

	[StructLayout(LayoutKind::Sequential, Pack = 1)]
	public value struct config_base_information_rf60x_net_t
	{
		SCANNER_TYPE_NET type;
		BAUR_RATE_UART_NET baud_rate;
		uint8_t network_address;
		String^ serial_port_number;
		PROTOCOLS_NET protocol;
	};

	   	 
	[StructLayout(LayoutKind::Sequential, Pack = 1)]
	public value struct uart_stream_measure_net_t
	{
		uint16_t value;
		uint8_t status;
		uint8_t reserverd;
	};


	[StructLayout(LayoutKind::Sequential, Pack = 1)]
	public value struct uart_result_with_encoder_net_t
	{
		uint16_t value;
		uint16_t rotationMarks;
		uint16_t encoderValue;
	};


	typedef struct {

	} ;


	[StructLayout(LayoutKind::Sequential, Pack = 1)]
	public value struct udp_value_net_t
	{
		uint16_t value;
		uint8_t status;
	};
	

	[StructLayout(LayoutKind::Sequential, Pack = 1)]
	public value struct modbus_rtu_command_net_t
	{
		uint8_t id;
		uint8_t command;
		uint16_t address;
		uint16_t count;
		uint16_t crc;
	};

  
	[StructLayout(LayoutKind::Sequential, Pack = 1)]
	public value struct udp_measure_net_t{

	private:
		static	bool intiliaze;

	public:
		[MarshalAs(UnmanagedType::ByValArray, SizeConst = 168)]
	    array<udp_value_net_t>^ Array;
		uint16_t deviceSerial;
		uint16_t deviceBaseDistance;
		uint16_t deviceMeasureRange;
		uint8_t packCount;
		uint8_t packetControlSumm;

		void  intiliazeArrays(uint16_t sizePoints, uint16_t sizePixels) {

			if (intiliaze) return;
			Array = gcnew array<udp_value_net_t>(168);
			intiliaze = true;
		}

	};

	public ref class rf60XsdkNet
	{

	public:

	   rf60XsdkNet(const config_base_information_rf60x_net_t%  config);


	  static bool sdk_init();

	  static void sdk_cleanup();


	  //Ethernet 
	   bool connect();


	   bool get_measure_udp(udp_measure_net_t%  clone);  //TODO    .

	   bool disconnect();
	   


	   //UART
	   bool open_port_uart();

	   uart_hello_rf60x_net_t hell_msg_uart();

	   void change_config_port_uart();

	   bool send_command(COMMAND_UART_NET CMD);

	   void close_port_uart();

	   bool get_measure_uart(uart_stream_measure_net_t% measure);

	   bool get_measure_uart(uart_result_with_encoder_net_t% measure);

	   bool send_command_modbus(modbus_rtu_command_net_t% command);

	   bool receive_data_modbus(array<System::UInt16>^ buffer);

	   bool read_params_uart();

	   byte get_param(PARAM_NAME_KEY_NET param);

	   bool set_param(byte value);

	   bool write_params_uart();



	   ~rf60XsdkNet();
	protected:
      	 SDK::SCANNERS::RF60X::rf60x  *_rf60x;
		 param_t *valueParam;
		 
	};
}
